let b = 10

type sign = Plus | Minus
(* type ifloat = sign * int lis * int lis *) (* only the second one can be infinite *)

let corec[constructor] addf_aux p = match p with
(* only floating part
   without taking into account carry-overs *)
  [], [] -> []
| h1 :: t1, [] -> h1 :: t1
| [], h2 :: t2 -> h2 :: t2
| h1 :: t1, h2 :: t2 -> (h1 + h2) :: (addf_aux (t1, t2))

let rec f1 = 5 :: 4 :: f1
let rec f2 = 5 :: 5 :: f2

let f3 = addf_aux (f1, f2)
(* val f3 : int list = [10; 9; 10; 9; 10; 9; 10; 9; 10; 9; 10; 9; 10; 9; 10; 9; 10; 9; 10; 9; ...] *)

let corec[iterator (0, [])] addf_aux2 s = match s with
  [] -> (0, [])
| h :: t -> match addf_aux2 t with 
    c, r -> (h + c)/10, ((h + c) mod 10) :: r

let f4 = addf_aux2 [46; 517]

let rec ones = 1 :: ones
(* let f6 = addf_aux2 ones *)
(*
0, [1]
0, [1; 1]
0, [1; 1; 1]
0, [1; 1; 1; 1]
0, [1; 1; 1; 1; 1]
0, [1; 1; 1; 1; 1; 1]
0, [1; 1; 1; 1; 1; 1; 1]
0, [1; 1; 1; 1; 1; 1; 1; 1]
0, [1; 1; 1; 1; 1; 1; 1; 1; 1]
0, [1; 1; 1; 1; 1; 1; 1; 1; 1; 1]
0, [1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1]
0, [1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1]
0, [1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1]
0, [1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1]
0, [1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1]
0, [1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1]
0, [1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1]
0, [1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1]
0, [1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1]
0, [1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; 1; ...]
...
*)
(*
let f6 = addf_aux2 f3
*)
(*
0, [9]
1, [0; 9]
1, [0; 0; 9]
1, [1; 0; 0; 9]
1, [0; 1; 0; 0; 9]
1, [1; 0; 1; 0; 0; 9]
1, [0; 1; 0; 1; 0; 0; 9]
1, [1; 0; 1; 0; 1; 0; 0; 9]
1, [0; 1; 0; 1; 0; 1; 0; 0; 9]
1, [1; 0; 1; 0; 1; 0; 1; 0; 0; 9]
1, [0; 1; 0; 1; 0; 1; 0; 1; 0; 0; 9]
1, [1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 0; 9]
1, [0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 0; 9]
1, [1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 0; 9]
1, [0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 0; 9]
1, [1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 0; 9]
1, [0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 0; 9]
1, [1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 0; 9]
1, [0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 0; 9]
1, [1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 1; 0; 0; 9; ...]
...
*)
let corec[constructor] addf_aux3 s = match s with
  [] -> (0, [])
| h :: t -> match addf_aux3 t with 
    c, r -> (h + c)/10, ((h + c) mod 10) :: r

let corec[iterator (0, [])] addf_aux4 s =
  addf_aux3 s
(*
let f7 = addf_aux4 ones
*)
(* EMatch failure *)

(* big issue: in addf_aux4 above, we return a *pair* and not just sth
   on which to apply the constructor. That's what messes up the whole
   thing (but also makes it interesting in a lot of ways.
   Below we don't return a pair anymore. It doesn't solve our problem
   but validates the remark above *)
let corec[constructor] addf_aux5 s = match s with
  [] -> []
| h :: t -> (h mod 10) :: (addf_aux5 s)

let corec[iterator []] addf_aux6 s =
  addf_aux5 s

let f8 = addf_aux5 ones
let f9 = addf_aux6 ones
