(********************************************************)
(* This is a stub on operations with rationals          *)
(* using the constriterator solver                      *)
(* author: Jean-Baptiste Jeannin jeannin@cs.cornell.edu *)
(********************************************************)

(* A = int, for now at least *)
(* open List *)

type state = State of int * (state * int) list

let rec q1 =
  let rec q2 = State(2, [q1, -1; q2, 2 ]) in
  State(1, [ q1, 0; q2, 1 ])

let sum = fold_left (fun a b -> a+b) 0

let list_of_stream (q:state) (i:int) =
  let rec list_of_stream_aux (i:int) (l:(int * state) list) =
    if i = 0 then [ ]
    else
      sum (map (function p, State(j, _) -> p * j) l) ::
	list_of_stream_aux (i-1)
	(flatten 
	   (map 
	      (function p, State(_, lstate) ->
		map (function s, i -> p * i, s) lstate)
	      l))
  in list_of_stream_aux i [1, q]

let r1 = list_of_stream q1 2
